]> git.saurik.com Git - bison.git/blobdiff - bootstrap
Work around a bug in bro 0.8, which underparenthesizes its
[bison.git] / bootstrap
index 1207d6b09909e9c98c6703e310d341f470c02457..7c7bd3300e33f0eba634ec35501e2b9b994d1cc9 100755 (executable)
--- a/bootstrap
+++ b/bootstrap
@@ -2,7 +2,7 @@
 
 # Bootstrap this package from CVS.
 
 
 # Bootstrap this package from CVS.
 
-# Copyright (C) 2003, 2004, 2005 Free Software Foundation, Inc.
+# Copyright (C) 2003, 2004, 2005, 2006 Free Software Foundation, Inc.
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -25,6 +25,7 @@ package=bison
 
 # Ensure file names are sorted consistently across platforms;
 # e.g., m4/ulonglong_gl.m4 should follow m4/ulonglong.m4.
 
 # Ensure file names are sorted consistently across platforms;
 # e.g., m4/ulonglong_gl.m4 should follow m4/ulonglong.m4.
+# Also, ensure diagnostics are in English, e.g., "wget --help" below.
 LC_ALL=C
 export LC_ALL
 
 LC_ALL=C
 export LC_ALL
 
@@ -50,11 +51,10 @@ done
 
 echo "$0: Bootstrapping CVS $package..."
 
 
 echo "$0: Bootstrapping CVS $package..."
 
-build_cvs_prefix() {
-  CVS_PREFIX=:${1}:
-  if [ "${2}" != - ]; then
-    CVS_PREFIX=${CVS_PREFIX}${2}@
-  fi
+cleanup_gnulib() {
+  status=$?
+  rm -fr gnulib
+  exit $status
 }
 
 # Get gnulib files.
 }
 
 # Get gnulib files.
@@ -64,12 +64,9 @@ case ${GNULIB_SRCDIR--} in
   if [ ! -d gnulib ]; then
     echo "$0: getting gnulib files..."
 
   if [ ! -d gnulib ]; then
     echo "$0: getting gnulib files..."
 
-    trap exit 1 2 13 15
-    trap 'rm -fr gnulib; exit 1' 0
-
-    case ${CVS_AUTH-anoncvs} in
-    anoncvs)
-      CVS_PREFIX='anoncvs@';;
+    case ${CVS_AUTH-pserver} in
+    pserver)
+      CVS_PREFIX=':pserver:anonymous@';;
     ssh)
       CVS_PREFIX="$CVS_USER${CVS_USER+@}";;
     *)
     ssh)
       CVS_PREFIX="$CVS_USER${CVS_USER+@}";;
     *)
@@ -81,9 +78,12 @@ case ${GNULIB_SRCDIR--} in
     '') export CVS_RSH=ssh;;
     esac
 
     '') export CVS_RSH=ssh;;
     esac
 
-    cvs -z3 -q -d ${CVS_PREFIX}subversions.gnu.org:/cvsroot/gnulib co gnulib || exit
+    trap cleanup_gnulib 1 2 13 15
+
+    cvs -z3 -q -d ${CVS_PREFIX}cvs.savannah.gnu.org:/cvsroot/gnulib co gnulib ||
+      cleanup_gnulib
 
 
-    trap - 0
+    trap - 1 2 13 15
   fi
   GNULIB_SRCDIR=gnulib
 esac
   fi
   GNULIB_SRCDIR=gnulib
 esac
@@ -91,7 +91,6 @@ esac
 <$GNULIB_SRCDIR/gnulib-tool || exit
 
 gnulib_modules='
 <$GNULIB_SRCDIR/gnulib-tool || exit
 
 gnulib_modules='
-alloca
 argmatch
 dirname
 error
 argmatch
 dirname
 error
@@ -108,7 +107,12 @@ quotearg
 stdbool
 stdio-safer
 stpcpy
 stdbool
 stdio-safer
 stpcpy
+strerror
+strtoul
+strverscmp
 unistd-safer
 unistd-safer
+unlocked-io
+verify
 xalloc
 xalloc-die
 xstrndup
 xalloc
 xalloc-die
 xstrndup
@@ -153,6 +157,8 @@ for gnulib_file in $gnulib_files; do
   cp -p $GNULIB_SRCDIR/$gnulib_file $dest || exit
 done
 
   cp -p $GNULIB_SRCDIR/$gnulib_file $dest || exit
 done
 
+# This suppresses a bogus diagnostic
+# "warning: macro `AM_LANGINFO_CODESET' not found in library".
 echo "$0: patching m4/gettext.m4 so that AM_INTL_SUBDIR is empty ..."
 sed '
   /^AC_DEFUN(\[AM_INTL_SUBDIR],/,/^]/c\
 echo "$0: patching m4/gettext.m4 so that AM_INTL_SUBDIR is empty ..."
 sed '
   /^AC_DEFUN(\[AM_INTL_SUBDIR],/,/^]/c\
@@ -164,10 +170,19 @@ sed '
 
 case $SKIP_PO in
 '')
 
 case $SKIP_PO in
 '')
+  case `wget --help` in
+  *'--no-cache'*)
+    no_cache='--no-cache';;
+  *'--cache=on/off'*)
+    no_cache='--cache=off';;
+  *)
+    no_cache='';;
+  esac
+
   echo "$0: getting translations into po (please ignore the robots.txt ERROR 404)..."
   (cd po &&
    rm -f dummy `ls | sed -n '/\.gmo$/p; /\.po/p'` &&
   echo "$0: getting translations into po (please ignore the robots.txt ERROR 404)..."
   (cd po &&
    rm -f dummy `ls | sed -n '/\.gmo$/p; /\.po/p'` &&
-   wget -nv -nd -r -l 1 -A .po -C off \
+   wget -nv -nd -r -l 1 -A .po $no_cache \
      http://www.iro.umontreal.ca/translation/maint/$package/ &&
    ls *.po | sed 's/\.po$//' >LINGUAS
   ) || exit
      http://www.iro.umontreal.ca/translation/maint/$package/ &&
    ls *.po | sed 's/\.po$//' >LINGUAS
   ) || exit
@@ -177,8 +192,36 @@ case $SKIP_PO in
     echo "$0: getting translations into po (please ignore the robots.txt ERROR 404)..."
     (cd runtime-po &&
      rm -f dummy `ls | sed -n '/\.gmo$/p; /\.po$/p'` &&
     echo "$0: getting translations into po (please ignore the robots.txt ERROR 404)..."
     (cd runtime-po &&
      rm -f dummy `ls | sed -n '/\.gmo$/p; /\.po$/p'` &&
-     wget -nv -nd -r -l 1 -A .po -C off \
+     wget -nv -nd -r -l 1 -A .po $no_cache \
        http://www.iro.umontreal.ca/translation/maint/$package-runtime/ &&
        http://www.iro.umontreal.ca/translation/maint/$package-runtime/ &&
+
+     # For translations that have not yet been upgraded to the new
+     # runtime-po domain, prime the pump by extracting the relevant
+     # strings from the obsolete translations.
+     # This code can be removed once the bison-runtime domain
+     # has been translated by each team.
+     for po in ../po/*.po; do
+       test -f "$po" || continue
+       runpo=`basename $po`
+       test -f $runpo || {
+        msggrep -K \
+            -e 'memory exhausted' \
+            -e 'syntax error' \
+            $po 2>/dev/null |
+          sed '
+            s/^#~ //
+            /^msgid "syntax error; also memory exhausted"$/,/^$/d
+            /^$/,${ /^#/d; }
+          ' >$runpo-
+        if cmp -s $runpo- $runpo; then
+          rm $runpo-
+        else
+          mv $runpo- $runpo
+        fi
+        test -s $runpo || rm -f $runpo
+       } || exit
+     done &&
+
      ls *.po | sed 's/\.po$//' >LINGUAS
     ) || exit
   esac;;
      ls *.po | sed 's/\.po$//' >LINGUAS
     ) || exit
   esac;;
@@ -238,6 +281,15 @@ intl_files_to_remove='
 echo $0: rm -fr $intl_files_to_remove ...
 rm -fr $intl_files_to_remove || exit
 
 echo $0: rm -fr $intl_files_to_remove ...
 rm -fr $intl_files_to_remove || exit
 
+# Undo changes to gnulib files that autoreconf made.
+for gnulib_file in $gnulib_files; do
+  test ! -f $gnulib_file || cmp -s $gnulib_file $GNULIB_SRCDIR/$gnulib_file || {
+    rm -f $gnulib_file &&
+    echo "$0: Copying file $GNULIB_SRCDIR/$gnulib_file again" &&
+    cp -p $GNULIB_SRCDIR/$gnulib_file $gnulib_file || exit
+  }
+done
+
 # Put bug-reporting address into po/Makevars.
 echo "$0: sed '/^MSGID_BUGS_ADDRESS *=/s/=.*/= bug-bison@gnu.org/' po/Makevars.template >po/Makevars ..."
 sed '/^MSGID_BUGS_ADDRESS *=/s/=.*/= bug-bison@gnu.org/' po/Makevars.template >po/Makevars
 # Put bug-reporting address into po/Makevars.
 echo "$0: sed '/^MSGID_BUGS_ADDRESS *=/s/=.*/= bug-bison@gnu.org/' po/Makevars.template >po/Makevars ..."
 sed '/^MSGID_BUGS_ADDRESS *=/s/=.*/= bug-bison@gnu.org/' po/Makevars.template >po/Makevars
@@ -246,11 +298,11 @@ sed '/^MSGID_BUGS_ADDRESS *=/s/=.*/= bug-bison@gnu.org/' po/Makevars.template >p
 sed '
   s/^\(DOMAIN\) *=.*/\1 = bison-runtime/
   s/^\(subdir\) *=.*/\1 = runtime-po/
 sed '
   s/^\(DOMAIN\) *=.*/\1 = bison-runtime/
   s/^\(subdir\) *=.*/\1 = runtime-po/
-  s/^\(XGETTEXT_OPTIONS\) *=.*/\1 = --keyword=YYI18N/
+  s/^\(XGETTEXT_OPTIONS\) *=.*/\1 = --keyword=YY_/
 ' <po/Makevars >runtime-po/Makevars
 
 # Copy identical files from po to runtime-po.
 ' <po/Makevars >runtime-po/Makevars
 
 # Copy identical files from po to runtime-po.
-(cd po && cp -p *-quot *.header *.sed *.sin ../runtime-po)
+(cd po && cp -p Makefile.in.in *-quot *.header *.sed *.sin ../runtime-po)
 
 # if src/parse-gram.[ch] are out of date, rebuild them.
 parse_gram_y=`find src/parse-gram.y \
 
 # if src/parse-gram.[ch] are out of date, rebuild them.
 parse_gram_y=`find src/parse-gram.y \